/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The object attributes managed by the KeyVault service.
 *
 */
class Attributes {
  /**
   * Create a Attributes.
   * @member {boolean} [enabled] Determines whether the object is enabled.
   * @member {date} [notBefore] Not before date in UTC.
   * @member {date} [expires] Expiry date in UTC.
   * @member {date} [created] Creation time in UTC.
   * @member {date} [updated] Last updated time in UTC.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Attributes
   *
   * @returns {object} metadata of Attributes
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Attributes',
      type: {
        name: 'Composite',
        className: 'Attributes',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          notBefore: {
            required: false,
            serializedName: 'nbf',
            type: {
              name: 'UnixTime'
            }
          },
          expires: {
            required: false,
            serializedName: 'exp',
            type: {
              name: 'UnixTime'
            }
          },
          created: {
            required: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'UnixTime'
            }
          },
          updated: {
            required: false,
            readOnly: true,
            serializedName: 'updated',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = Attributes;
