/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The certificate merge parameters
 *
 */
class CertificateMergeParameters {
  /**
   * Create a CertificateMergeParameters.
   * @member {array} x509Certificates The certificate or the certificate chain
   * to merge.
   * @member {object} [certificateAttributes] The attributes of the certificate
   * (optional).
   * @member {string} [certificateAttributes.recoveryLevel] Reflects the
   * deletion recovery level currently in effect for certificates in the
   * current vault. If it contains 'Purgeable', the certificate can be
   * permanently deleted by a privileged user; otherwise, only the system can
   * purge the certificate, at the end of the retention interval. Possible
   * values include: 'Purgeable', 'Recoverable+Purgeable', 'Recoverable',
   * 'Recoverable+ProtectedSubscription'
   * @member {object} [tags] Application specific metadata in the form of
   * key-value pairs.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CertificateMergeParameters
   *
   * @returns {object} metadata of CertificateMergeParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CertificateMergeParameters',
      type: {
        name: 'Composite',
        className: 'CertificateMergeParameters',
        modelProperties: {
          x509Certificates: {
            required: true,
            serializedName: 'x5c',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'BufferElementType',
                  type: {
                    name: 'ByteArray'
                  }
              }
            }
          },
          certificateAttributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'CertificateAttributes'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CertificateMergeParameters;
