/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A Deleted Certificate consisting of its previous id, attributes and its
 * tags, as well as information on when it will be purged.
 *
 * @extends models['CertificateBundle']
 */
class DeletedCertificateBundle extends models['CertificateBundle'] {
  /**
   * Create a DeletedCertificateBundle.
   * @member {string} [recoveryId] The url of the recovery object, used to
   * identify and recover the deleted certificate.
   * @member {date} [scheduledPurgeDate] The time when the certificate is
   * scheduled to be purged, in UTC
   * @member {date} [deletedDate] The time when the certificate was deleted, in
   * UTC
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeletedCertificateBundle
   *
   * @returns {object} metadata of DeletedCertificateBundle
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedCertificateBundle',
      type: {
        name: 'Composite',
        className: 'DeletedCertificateBundle',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          kid: {
            required: false,
            readOnly: true,
            serializedName: 'kid',
            type: {
              name: 'String'
            }
          },
          sid: {
            required: false,
            readOnly: true,
            serializedName: 'sid',
            type: {
              name: 'String'
            }
          },
          x509Thumbprint: {
            required: false,
            readOnly: true,
            serializedName: 'x5t',
            type: {
              name: 'Base64Url'
            }
          },
          policy: {
            required: false,
            readOnly: true,
            serializedName: 'policy',
            type: {
              name: 'Composite',
              className: 'CertificatePolicy'
            }
          },
          cer: {
            required: false,
            serializedName: 'cer',
            type: {
              name: 'ByteArray'
            }
          },
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          },
          attributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'CertificateAttributes'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          recoveryId: {
            required: false,
            serializedName: 'recoveryId',
            type: {
              name: 'String'
            }
          },
          scheduledPurgeDate: {
            required: false,
            readOnly: true,
            serializedName: 'scheduledPurgeDate',
            type: {
              name: 'UnixTime'
            }
          },
          deletedDate: {
            required: false,
            readOnly: true,
            serializedName: 'deletedDate',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedCertificateBundle;
