/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The deleted SAS definition item containing metadata about the deleted SAS
 * definition.
 *
 * @extends models['SasDefinitionItem']
 */
class DeletedSasDefinitionItem extends models['SasDefinitionItem'] {
  /**
   * Create a DeletedSasDefinitionItem.
   * @member {string} [recoveryId] The url of the recovery object, used to
   * identify and recover the deleted SAS definition.
   * @member {date} [scheduledPurgeDate] The time when the SAS definition is
   * scheduled to be purged, in UTC
   * @member {date} [deletedDate] The time when the SAS definition was deleted,
   * in UTC
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeletedSasDefinitionItem
   *
   * @returns {object} metadata of DeletedSasDefinitionItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedSasDefinitionItem',
      type: {
        name: 'Composite',
        className: 'DeletedSasDefinitionItem',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          secretId: {
            required: false,
            readOnly: true,
            serializedName: 'sid',
            type: {
              name: 'String'
            }
          },
          attributes: {
            required: false,
            readOnly: true,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'SasDefinitionAttributes'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          recoveryId: {
            required: false,
            serializedName: 'recoveryId',
            type: {
              name: 'String'
            }
          },
          scheduledPurgeDate: {
            required: false,
            readOnly: true,
            serializedName: 'scheduledPurgeDate',
            type: {
              name: 'UnixTime'
            }
          },
          deletedDate: {
            required: false,
            readOnly: true,
            serializedName: 'deletedDate',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedSasDefinitionItem;
