/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A Deleted Secret consisting of its previous id, attributes and its tags, as
 * well as information on when it will be purged.
 *
 * @extends models['SecretBundle']
 */
class DeletedSecretBundle extends models['SecretBundle'] {
  /**
   * Create a DeletedSecretBundle.
   * @member {string} [recoveryId] The url of the recovery object, used to
   * identify and recover the deleted secret.
   * @member {date} [scheduledPurgeDate] The time when the secret is scheduled
   * to be purged, in UTC
   * @member {date} [deletedDate] The time when the secret was deleted, in UTC
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeletedSecretBundle
   *
   * @returns {object} metadata of DeletedSecretBundle
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedSecretBundle',
      type: {
        name: 'Composite',
        className: 'DeletedSecretBundle',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          },
          attributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'SecretAttributes'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          kid: {
            required: false,
            readOnly: true,
            serializedName: 'kid',
            type: {
              name: 'String'
            }
          },
          managed: {
            required: false,
            readOnly: true,
            serializedName: 'managed',
            type: {
              name: 'Boolean'
            }
          },
          recoveryId: {
            required: false,
            serializedName: 'recoveryId',
            type: {
              name: 'String'
            }
          },
          scheduledPurgeDate: {
            required: false,
            readOnly: true,
            serializedName: 'scheduledPurgeDate',
            type: {
              name: 'UnixTime'
            }
          },
          deletedDate: {
            required: false,
            readOnly: true,
            serializedName: 'deletedDate',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedSecretBundle;
