/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The deleted secret item containing metadata about the deleted secret.
 *
 * @extends models['SecretItem']
 */
class DeletedSecretItem extends models['SecretItem'] {
  /**
   * Create a DeletedSecretItem.
   * @member {string} [recoveryId] The url of the recovery object, used to
   * identify and recover the deleted secret.
   * @member {date} [scheduledPurgeDate] The time when the secret is scheduled
   * to be purged, in UTC
   * @member {date} [deletedDate] The time when the secret was deleted, in UTC
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeletedSecretItem
   *
   * @returns {object} metadata of DeletedSecretItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedSecretItem',
      type: {
        name: 'Composite',
        className: 'DeletedSecretItem',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          attributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'SecretAttributes'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          contentType: {
            required: false,
            serializedName: 'contentType',
            type: {
              name: 'String'
            }
          },
          managed: {
            required: false,
            readOnly: true,
            serializedName: 'managed',
            type: {
              name: 'Boolean'
            }
          },
          recoveryId: {
            required: false,
            serializedName: 'recoveryId',
            type: {
              name: 'String'
            }
          },
          scheduledPurgeDate: {
            required: false,
            readOnly: true,
            serializedName: 'scheduledPurgeDate',
            type: {
              name: 'UnixTime'
            }
          },
          deletedDate: {
            required: false,
            readOnly: true,
            serializedName: 'deletedDate',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedSecretItem;
