/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The deleted storage account item containing metadata about the deleted
 * storage account.
 *
 * @extends models['StorageAccountItem']
 */
class DeletedStorageAccountItem extends models['StorageAccountItem'] {
  /**
   * Create a DeletedStorageAccountItem.
   * @member {string} [recoveryId] The url of the recovery object, used to
   * identify and recover the deleted storage account.
   * @member {date} [scheduledPurgeDate] The time when the storage account is
   * scheduled to be purged, in UTC
   * @member {date} [deletedDate] The time when the storage account was
   * deleted, in UTC
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeletedStorageAccountItem
   *
   * @returns {object} metadata of DeletedStorageAccountItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedStorageAccountItem',
      type: {
        name: 'Composite',
        className: 'DeletedStorageAccountItem',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            readOnly: true,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          attributes: {
            required: false,
            readOnly: true,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'StorageAccountAttributes'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          recoveryId: {
            required: false,
            serializedName: 'recoveryId',
            type: {
              name: 'String'
            }
          },
          scheduledPurgeDate: {
            required: false,
            readOnly: true,
            serializedName: 'scheduledPurgeDate',
            type: {
              name: 'UnixTime'
            }
          },
          deletedDate: {
            required: false,
            readOnly: true,
            serializedName: 'deletedDate',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedStorageAccountItem;
