/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A deleted storage account bundle consisting of its previous id, attributes
 * and its tags, as well as information on when it will be purged.
 *
 * @extends models['StorageBundle']
 */
class DeletedStorageBundle extends models['StorageBundle'] {
  /**
   * Create a DeletedStorageBundle.
   * @member {string} [recoveryId] The url of the recovery object, used to
   * identify and recover the deleted storage account.
   * @member {date} [scheduledPurgeDate] The time when the storage account is
   * scheduled to be purged, in UTC
   * @member {date} [deletedDate] The time when the storage account was
   * deleted, in UTC
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DeletedStorageBundle
   *
   * @returns {object} metadata of DeletedStorageBundle
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeletedStorageBundle',
      type: {
        name: 'Composite',
        className: 'DeletedStorageBundle',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            readOnly: true,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          activeKeyName: {
            required: false,
            readOnly: true,
            serializedName: 'activeKeyName',
            type: {
              name: 'String'
            }
          },
          autoRegenerateKey: {
            required: false,
            readOnly: true,
            serializedName: 'autoRegenerateKey',
            type: {
              name: 'Boolean'
            }
          },
          regenerationPeriod: {
            required: false,
            readOnly: true,
            serializedName: 'regenerationPeriod',
            type: {
              name: 'String'
            }
          },
          attributes: {
            required: false,
            readOnly: true,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'StorageAccountAttributes'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          recoveryId: {
            required: false,
            serializedName: 'recoveryId',
            type: {
              name: 'String'
            }
          },
          scheduledPurgeDate: {
            required: false,
            readOnly: true,
            serializedName: 'scheduledPurgeDate',
            type: {
              name: 'UnixTime'
            }
          },
          deletedDate: {
            required: false,
            readOnly: true,
            serializedName: 'deletedDate',
            type: {
              name: 'UnixTime'
            }
          }
        }
      }
    };
  }
}

module.exports = DeletedStorageBundle;
