/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The key vault server error.
 *
 */
class ErrorModel {
  /**
   * Create a ErrorModel.
   * @member {string} [code] The error code.
   * @member {string} [message] The error message.
   * @member {object} [innerError]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorModel
   *
   * @returns {object} metadata of ErrorModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Error',
      type: {
        name: 'Composite',
        className: 'ErrorModel',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          innerError: {
            required: false,
            readOnly: true,
            serializedName: 'innererror',
            type: {
              name: 'Composite',
              className: 'ErrorModel'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorModel;
