/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The credentials to be used for the certificate issuer.
 *
 */
class IssuerCredentials {
  /**
   * Create a IssuerCredentials.
   * @member {string} [accountId] The user name/account name/account id.
   * @member {string} [password] The password/secret/account key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IssuerCredentials
   *
   * @returns {object} metadata of IssuerCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IssuerCredentials',
      type: {
        name: 'Composite',
        className: 'IssuerCredentials',
        modelProperties: {
          accountId: {
            required: false,
            serializedName: 'account_id',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'pwd',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IssuerCredentials;
