/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The key operations parameters.
 *
 */
class KeyOperationsParameters {
  /**
   * Create a KeyOperationsParameters.
   * @member {string} algorithm algorithm identifier. Possible values include:
   * 'RSA-OAEP', 'RSA-OAEP-256', 'RSA1_5'
   * @member {buffer} value
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyOperationsParameters
   *
   * @returns {object} metadata of KeyOperationsParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyOperationsParameters',
      type: {
        name: 'Composite',
        className: 'KeyOperationsParameters',
        modelProperties: {
          algorithm: {
            required: true,
            serializedName: 'alg',
            constraints: {
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'Base64Url'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyOperationsParameters;
