/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The key update parameters.
 *
 */
class KeyUpdateParameters {
  /**
   * Create a KeyUpdateParameters.
   * @member {array} [keyOps] Json web key operations. For more information on
   * possible key operations, see JsonWebKeyOperation.
   * @member {object} [keyAttributes]
   * @member {string} [keyAttributes.recoveryLevel] Reflects the deletion
   * recovery level currently in effect for keys in the current vault. If it
   * contains 'Purgeable' the key can be permanently deleted by a privileged
   * user; otherwise, only the system can purge the key, at the end of the
   * retention interval. Possible values include: 'Purgeable',
   * 'Recoverable+Purgeable', 'Recoverable',
   * 'Recoverable+ProtectedSubscription'
   * @member {object} [tags] Application specific metadata in the form of
   * key-value pairs.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyUpdateParameters
   *
   * @returns {object} metadata of KeyUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyUpdateParameters',
      type: {
        name: 'Composite',
        className: 'KeyUpdateParameters',
        modelProperties: {
          keyOps: {
            required: false,
            serializedName: 'key_ops',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          keyAttributes: {
            required: false,
            serializedName: 'attributes',
            type: {
              name: 'Composite',
              className: 'KeyAttributes'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = KeyUpdateParameters;
