/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The key verify parameters.
 *
 */
class KeyVerifyParameters {
  /**
   * Create a KeyVerifyParameters.
   * @member {string} algorithm The signing/verification algorithm. For more
   * information on possible algorithm types, see JsonWebKeySignatureAlgorithm.
   * Possible values include: 'PS256', 'PS384', 'PS512', 'RS256', 'RS384',
   * 'RS512', 'RSNULL', 'ES256', 'ES384', 'ES512', 'ES256K'
   * @member {buffer} digest The digest used for signing.
   * @member {buffer} signature The signature to be verified.
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVerifyParameters
   *
   * @returns {object} metadata of KeyVerifyParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVerifyParameters',
      type: {
        name: 'Composite',
        className: 'KeyVerifyParameters',
        modelProperties: {
          algorithm: {
            required: true,
            serializedName: 'alg',
            constraints: {
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          digest: {
            required: true,
            serializedName: 'digest',
            type: {
              name: 'Base64Url'
            }
          },
          signature: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'Base64Url'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVerifyParameters;
