/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The storage account management attributes.
 *
 */
class StorageAccountAttributes {
  /**
   * Create a StorageAccountAttributes.
   * @member {boolean} [enabled] the enabled state of the object.
   * @member {date} [created] Creation time in UTC.
   * @member {date} [updated] Last updated time in UTC.
   * @member {string} [recoveryLevel] Reflects the deletion recovery level
   * currently in effect for storage accounts in the current vault. If it
   * contains 'Purgeable' the storage account can be permanently deleted by a
   * privileged user; otherwise, only the system can purge the storage account,
   * at the end of the retention interval. Possible values include:
   * 'Purgeable', 'Recoverable+Purgeable', 'Recoverable',
   * 'Recoverable+ProtectedSubscription'
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageAccountAttributes
   *
   * @returns {object} metadata of StorageAccountAttributes
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccountAttributes',
      type: {
        name: 'Composite',
        className: 'StorageAccountAttributes',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          created: {
            required: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'UnixTime'
            }
          },
          updated: {
            required: false,
            readOnly: true,
            serializedName: 'updated',
            type: {
              name: 'UnixTime'
            }
          },
          recoveryLevel: {
            required: false,
            readOnly: true,
            serializedName: 'recoveryLevel',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccountAttributes;
